package com.jscape.inet.sftp.protocol.v3.marshaling;

import com.jscape.inet.sftp.protocol.messages.Message;
import com.jscape.inet.sftp.protocol.v3.messages.SshFxpSymLink;
import com.jscape.inet.ssh.protocol.v2.marshaling.primitive.StringCodec;
import com.jscape.inet.ssh.protocol.v2.marshaling.primitive.Uint32Codec;
import com.jscape.util.io.DataCodec;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

/**
 * @author Alex Usun
 */
public class SshFxpSymLinkCodec
        implements DataCodec<Message> {

    @Override
    public Message read(InputStream in)
            throws IOException {
        int id = Uint32Codec.readValue(in);
        String linkPath = StringCodec.readUtf8Value(in);
        String targetPath = StringCodec.readUtf8Value(in);

        return new SshFxpSymLink(id, linkPath, targetPath);
    }

    @Override
    public void write(Message value, OutputStream out)
            throws IOException {
        SshFxpSymLink message = (SshFxpSymLink) value;
        Uint32Codec.writeValue(message.id, out);
        StringCodec.writeUtf8Value(message.linkPath, out);
        StringCodec.writeUtf8Value(message.targetPath, out);
    }

}
